package com.agilecontrol.nea.core.security;

import com.agilecontrol.nea.core.control.web.WebUtils;
import java.util.Date;
import java.util.Random;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class CheckNO {

   private static final Logger logger = LoggerFactory.getLogger(CheckNO.class);
   private static CheckNO instance = null;
   private int checkInterval = -1;
   private long seed;
   private long nextChangeTime = 0L;
   private int currentValue;


   public static CheckNO getInstance() {
      if(instance == null) {
         instance = new CheckNO();
      }

      return instance;
   }

   private void computeValue() {
      if(this.checkInterval == -1) {
         try {
            this.checkInterval = 1000 * Integer.parseInt(WebUtils.getProperty("auth.impl.otp.interval"));
         } catch (Throwable var4) {
            logger.error("Error auth.impl.otp.interval in portal.properties:" + WebUtils.getProperty("auth.impl.otp.interval"));
         }

         this.seed = System.currentTimeMillis();
      }

      if(this.checkInterval <= 0) {
         this.checkInterval = 120000;
      }

      long time = System.currentTimeMillis();
      this.nextChangeTime = time / (long)this.checkInterval * (long)this.checkInterval + (long)this.checkInterval;
      Random r = new Random(time / (long)this.checkInterval * (long)this.checkInterval + this.seed);

      for(this.currentValue = Math.abs((Math.abs(r.nextInt()) + 1) % 9999); this.currentValue < 999; this.currentValue = Math.abs((Math.abs(r.nextInt()) + 1) % 9999)) {
         ;
      }

   }

   public int currentValue() {
      if(System.currentTimeMillis() > this.nextChangeTime) {
         this.computeValue();
      }

      return this.currentValue;
   }

   public static void main(String[] args) throws Exception {
      int checkno2 = 0;

      while(true) {
         int checkno1 = getInstance().currentValue();
         if(checkno2 != checkno1) {
            System.out.println(new Date() + ":" + checkno1);
         }

         checkno2 = checkno1;
         Thread.sleep(1000L);
      }
   }

}
